Resolution: Solved Issue FAQ Links:  

Description

Supportanfrage

Gibt es eine Möglichkeit die neuste Version der IFHD lib 0.8.0 auch mit Libs für VisualStudio 2017 zu bekommen?

In der Version 0.7.2 gibt es nämlich scheinbar einen Bug, dass die Zeit im Mediasample in Mikrosekunden umgerechnet wird und

dadurch die Informationen der letzten 3 Stellen verloren gehen (auch wenn ich als Zeitformat adtf3ns auswähle):

std::shared_ptr<Writer> writer(new Writer(filename, std::chrono::nanoseconds(0) , adtf3::

StandardTypeSerializers(), Writer::adtf3ns));

DefaultSample sample;

sample.setTimeStamp(std::chrono::nanoseconds(iTimestampNanoSec));

...

//write the sample to the file

writer->write(stream_id, std::chrono::nanoseconds(iTimestampNanoSec), sample);

 Wenn iTimestampNanoSec den Wert 472001001 hat, enthält die Sample-Zeit fälschlicherweise nur 472001000.
Ob das Problem noch in der Version 0.8.0 auftritt, konnte ich nicht verifizieren, das wir im Projekt bei uns nur VisualStudio 2017

nutzen.

Lösung

Das ist kein Bug, sondern ihr müsst beim Erstellen des Streams einfach den Serialisierer wechseln, also statt dem

SampleCopySerializer müsst ihr den SampleCopySerializerNs nehmen.

History

#1 - 2022-01-31 08:33 - hidden

- Project changed from Public Support to 11

- Status changed from New to In Progress

- Customer set to AUDI

- Department set to AST

- Topic set to ADTF::Datexporter

- Affected Products ADTF 3.13.2 added

- Platform Windows 10 64bit added

#2 - 2022-01-31 09:31 - hidden

- Description updated

- Topic changed from ADTF::Datexporter to FileLibrary::Writer

Hallo Dirk,
die ADTF File Library wird ab der Version 0.8.0 ausschließlich für die neuen zwischen CARIAD und Digitalwerk (ADTF und FEP) abgestimmten

Profile und Kundenforum beschlossenen Plattformen geliefert.

Wenn ein gravierender Bug in einer alten Version vorliegt und ihr aufgrund von Serienabhängigkeiten nicht umsteigen könnt, gilt wie beim ADTF

auch, eher die alte Version zu patchen (wenn Code-abhängig möglich).

Da sich die IFHD aber noch in der 0er Serie / BETA befindet, gehe ich davon nicht aus.

So oder so müssen wir prüfen, ob a) ein Bug vorliegt und b) wo wir ihn beheben können.

@Martin ?

PS: Da die Library open source ist, könnt ihr natürlich auch neuere Stände mit alten Profilen selbst erstellen.

#3 - 2022-01-31 09:42 - hidden

Hi Dirk,

das ist kein Bug, sondern ihr müsst beim Erstellen des Streams einfach den Serialisierer wechseln, also statt dem SampleCopySerializer müsst ihr

den SampleCopySerializerNs nehmen.

Grüße,

Martin

#4 - 2022-02-03 07:04 - hidden

Anwender Feedback von Dirk: (wurde wg System Problem nicht automatisch übernommen)

Danke für die schnelle Antwort. Das habe ich jetzt auch gerade rausgefunden, nachdem ich mir den Assembler Code angeschaut hatte. Damit

funktioniert es jetzt. Das war nur irgendwie nicht so selbsterklärend, dass der Serializer auch auf Nanosekunden umgestellt werden muss.

Ist der Code für ADTF-File eigentlich auch OpenSource, weil sich das im Assembler Code anzuschauen, war ein bisschen mühsam^^?

Viele Grüße

Dirk

#5 - 2022-02-03 07:31 - hidden

- Status changed from In Progress to Customer Feedback Required

Hallo Dirk,

ja, die IFHD steht unter MPL 2.0 und ist demnach open source.

Sie befindet sich im github der CARIAD (siehe auch Overview_of_Products_and_Documentation:

https://github.com/cariad-tech/adtf_file

Wie du vielleicht weißt, entwickelt die CARIAD FEP und sonstige OSS Produkte intern in der CIP und spiegelt sie dann nach außen.

Deshalb ist der Stand der IFHD leider noch sehr alt...

Solltest du Zugriff haben, hier liegt der "Original Code":

https://www.cip.audi.de/bitbucket/projects/OPENDEV/repos/odifhd/browse

Solltest du dort nicht drauf kommen, kann ich dir auch den aktuellsten Tag ziehen.

#6 - 2022-02-03 11:12 - hidden

Anwenderfeedback (manuell übernommen wg Email Problem):

Wenn du mir den Stand 0.7.2 und den 0.9.0 vom letzten Release geben könntest, wäre super :) . Auf das CIP Bitbucket habe ich leider keinen

Zugriff.

Vielen Dank.

 Hallo Dirk, bitte keine HTML formatierten Smileys senden, das bleibt leider aktuell im Email-Import hängen.

#7 - 2022-02-03 13:12 - hidden

- File odifhd-release-0.7.2@017d442976c.zip added

- File odifhd-release-0.9.0@0295cc68f0e.zip added

- Subject changed from IFHD Lib für VisualStudio 2017 to IFHD Lib for Visual Studio 2017 vc141

- Description updated
https://support.digitalwerk.net/projects/download-center/wiki/Overview_of_Products_and_Documentation
https://github.com/cariad-tech/adtf_file
https://www.cip.audi.de/bitbucket/projects/OPENDEV/repos/odifhd/browse


- Status changed from Customer Feedback Required to To Be Closed

- Resolution set to Solved Issue

See Anhang

#8 - 2022-02-03 13:12 - hidden

- File deleted (image004.jpg)

#9 - 2022-02-03 13:13 - hidden

- Project changed from 11 to Public Support

- Subject changed from IFHD Lib for Visual Studio 2017 vc141 to Receiving timestamp in microseconds instead of nanoseconds

- Status changed from To Be Closed to Closed

- Private changed from Yes to No

#10 - 2022-02-03 15:15 - hidden

Alles klar. Merke ich mir.

Könntet ihr mir dann noch den Source-Code von 0.7.2 und 0.9.0 zur Verfügung stellen? Danke.

#11 - 2022-02-03 15:25 - hidden

Hallo Dirk,

Könntet ihr mir dann noch den Source-Code von 0.7.2 und 0.9.0 zur Verfügung stellen? Danke.

 Siehe letzter Kommentar #16566#note-6

#12 - 2022-02-04 09:15 - hidden

Das hatte ich übersehen. Vielen Dank. Dann kann das Ticket geschlossen werden.
